<template>
    <div class="payform__methods-list" ref="list">
       <div class="payform__methods-list-list">
           <div v-for="method in methods"
                @click="$emit('input', method.type)"
                :key="method.type"
                class="payform__methods-list-list-item"
                :class="{active: method.type === value}"
           >
               <div class="icon">
                   <ui-icon view-box="0 0 50 50" :fill="$ui.colors.gray">{{icon[method.type]}}</ui-icon>
               </div>
               <div class="title">
                   {{title[method.type]}}
               </div>
           </div>
       </div>
        <div class="payform__methods-list-more" @click="expanded = !expanded" v-if="$interface.isMobile && methods.length > 1">
            <span>{{expanded ?  'Свернуть' : 'Показать еще'}}</span>
            <ui-icon :color="$ui.colors.gray" :rotate="expanded ? 180 : 0">collapse-20</ui-icon>
        </div>
    </div>
</template>

<script>
    import {icon, title} from '../common/methods';
    export default {
        name: 'component-payform-method-list',
        props: {
            value: {
                required: true,
                type: String,
            }
        },
        data () {
            return {
                loading: true,
                expanded: false,
                icon, title
            }
        },
        computed: {
            /**
             *
             * @returns [iPaymentMethods]
             */
            methods () {

                return  [{type: 'card', main: true,}];

                const methods = [{type: 'card', main: true,}, {type: 'sberbank', main: false,}, {type: 'yandex', main: false,}, {type: 'qiwi', main: false}];
                const unique = {};

                return methods.concat(this.$pay.methods).filter((method) => {
                    if(!unique[method.type]) {
                        unique[method.type] = true;
                        return true;
                    }

                    return false;
                }).filter((method) => {
                    return this.expanded || method.main;
                });
            }
        },

        watch: {
            expanded () {
                this.$nextTick(() => {
                    this.$helpers.scroll(this.findRoot(this));
                })
            }
        },

        created () {
            this.expanded = !this.$interface.isMobile;
            this.$store.dispatch('PAYMENT_GET_METHODS').finally(() => {
                this.loading = false;
            });
        },

        methods: {
            findRoot(root) {
                return root.$refs.payform ? root.$refs.payform :
                    root.$parent ? this.findRoot(root.$parent) : '';
            }
        }
    };
</script>

<style scoped>

</style>
